DynaActionForm (Apache Struts API Documentation)
Keywords: org.apache.struts.action.DynaActionForm,DynaActionForm class

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.struts.action
Class DynaActionForm

    java.lang.Object
      |
      +--org.apache.struts.action.ActionForm
            |
            +--org.apache.struts.action.DynaActionForm

All Implemented Interfaces:
  org.apache.commons.beanutils.DynaBean, java.io.Serializable

Direct Known Subclasses:
  DynaValidatorForm

public class DynaActionForm
extends ActionForm
implements org.apache.commons.beanutils.DynaBean

Specialized subclass of `ActionForm` that allows the creation of form beans with dynamic sets of properties, without requiring the developer to create a Java class for each type of form bean.

USAGE NOTE - Since Struts 1.1, the `reset()` method no longer initializes property values to those specified in `<form-property>` elements in the Struts module configuration file. If you wish to utilize that behavior, the simplest solution is to subclass `DynaActionForm` and call the `initialize()` method inside it.

Since:
  Struts 1.1
Version:
  $Revision: 1.1 $ $Date: 2003-08-22 09:14:33 +0100 (Fri, 22 Aug 2003) $
Author:
  Craig R. McClanahan
See Also:
  Serialized Form

Field Summary
`protected DynaActionFormClass` | `dynaClass` The DynaActionFormClass with which we are associated.
`protected java.util.HashMap` | `dynaValues` The set of property values for this DynaActionForm, keyed by property name.

Fields inherited from class org.apache.struts.action.ActionForm
`multipartRequestHandler, servlet`

Constructor Summary
`DynaActionForm()`

Method Summary
`boolean` | `contains(java.lang.String name, java.lang.String key)` Indicates if the specified mapped property contain a value for the specified key value.
`java.lang.Object` | `get(java.lang.String name)` Return the value of a simple property with the specified name.
`java.lang.Object` | `get(java.lang.String name, int index)` Return the value of an indexed property with the specified name.
`java.lang.Object` | `get(java.lang.String name, java.lang.String key)` Return the value of a mapped property with the specified name, or `null` if there is no value for the specified key.
`org.apache.commons.beanutils.DynaClass` | `getDynaClass()` Return the `DynaClass` instance that describes the set of properties available for this DynaBean.
`protected org.apache.commons.beanutils.DynaProperty` | `getDynaProperty(java.lang.String name)` Return the property descriptor for the specified property name.
`java.util.Map` | `getMap()` Returns the `Map` containing the property values.
`void` | `initialize(ActionMapping mapping)` Initialize all bean properties to their initial values, as specified in the `FormPropertyConfig` elements associated with the definition of this `DynaActionForm`.
`protected boolean` | `isDynaAssignable(java.lang.Class dest, java.lang.Class source)` Indicates if an object of the source class is assignable to the destination class.
`void` | `remove(java.lang.String name, java.lang.String key)` Remove any existing value for the specified key on the specified mapped property.
`void` | `reset(ActionMapping mapping, javax.servlet.http.HttpServletRequest request)` Reset all bean properties to their default state.
`void` | `reset(ActionMapping mapping, javax.servlet.ServletRequest request)` Reset all bean properties to their default state.
`void` | `set(java.lang.String name, int index, java.lang.Object value)` Set the value of an indexed property with the specified name.
`void` | `set(java.lang.String name, java.lang.Object value)` Set the value of a simple property with the specified name.
`void` | `set(java.lang.String name, java.lang.String key, java.lang.Object value)` Set the value of a mapped property with the specified name.
`(package private) void` | `setDynaActionFormClass(DynaActionFormClass dynaClass)` Set the DynaActionFormClass instance that we are associated with.
`java.lang.String` | `toString()` Render a String representation of this object.

Methods inherited from class org.apache.struts.action.ActionForm
`getMultipartRequestHandler, getServlet, getServletWrapper, setMultipartRequestHandler, setServlet, validate, validate`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### dynaClass

    protected DynaActionFormClass dynaClass

  The DynaActionFormClass with which we are associated.

### dynaValues

    protected java.util.HashMap dynaValues

  The set of property values for this DynaActionForm, keyed by property name.

Constructor Detail

### DynaActionForm

    public DynaActionForm()

Method Detail

### initialize

    public void initialize(ActionMapping mapping)

  Initialize all bean properties to their initial values, as specified in the `FormPropertyConfig` elements associated with the definition of this `DynaActionForm`.

  Parameters:
    `mapping` - The mapping used to select this instance
  Since:
    Struts 1.1

### reset

    public void reset(ActionMapping mapping,
                      javax.servlet.ServletRequest request)

  Reset all bean properties to their default state. This method is called before the properties are repopulated by the controller servlet.

  The default implementation attempts to forward to the HTTP version of this method.

  Overrides:
    `reset` in class `ActionForm`
  Parameters:
    `mapping` - The mapping used to select this instance
    `request` - The servlet request we are processing

### reset

    public void reset(ActionMapping mapping,
                      javax.servlet.http.HttpServletRequest request)

  Reset all bean properties to their default state. This method is called before the properties are repopulated by the controller servlet.

  The default implementation (since Struts 1.1) does nothing. Subclasses may override this method to reset bean properties to default values, or the `initialize()` method may be used to initialize property values to those provided in the form property configuration information (which was the previous behavior of this method).

  Overrides:
    `reset` in class `ActionForm`
  Parameters:
    `mapping` - The mapping used to select this instance
    `request` - The servlet request we are processing

### contains

    public boolean contains(java.lang.String name,
                            java.lang.String key)

  Indicates if the specified mapped property contain a value for the specified key value.

  Specified by:
    `contains` in interface `org.apache.commons.beanutils.DynaBean`
  Parameters:
    `name` - Name of the property to check
    `key` - Name of the key to check
  Throws:
    `java.lang.IllegalArgumentException` - if there is no property of the specified name

### get

    public java.lang.Object get(java.lang.String name)

  Return the value of a simple property with the specified name.

  Specified by:
    `get` in interface `org.apache.commons.beanutils.DynaBean`
  Parameters:
    `name` - Name of the property whose value is to be retrieved
  Throws:
    `java.lang.IllegalArgumentException` - if there is no property of the specified name
    `java.lang.NullPointerException` - if the type specified for the property is invalid

### get

    public java.lang.Object get(java.lang.String name,
                                int index)

  Return the value of an indexed property with the specified name.

  Specified by:
    `get` in interface `org.apache.commons.beanutils.DynaBean`
  Parameters:
    `name` - Name of the property whose value is to be retrieved
    `index` - Index of the value to be retrieved
  Throws:
    `java.lang.IllegalArgumentException` - if there is no property of the specified name
    `java.lang.IllegalArgumentException` - if the specified property exists, but is not indexed
    `java.lang.IndexOutOfBoundsException` - if the specified index is outside the range of the underlying property
    `java.lang.NullPointerException` - if no array or List has been initialized for this property

### get

    public java.lang.Object get(java.lang.String name,
                                java.lang.String key)

  Return the value of a mapped property with the specified name, or `null` if there is no value for the specified key.

  Specified by:
    `get` in interface `org.apache.commons.beanutils.DynaBean`
  Parameters:
    `name` - Name of the property whose value is to be retrieved
    `key` - Key of the value to be retrieved
  Throws:
    `java.lang.IllegalArgumentException` - if there is no property of the specified name
    `java.lang.IllegalArgumentException` - if the specified property exists, but is not mapped

### getDynaClass

    public org.apache.commons.beanutils.DynaClass getDynaClass()

  Return the `DynaClass` instance that describes the set of properties available for this DynaBean.

  Specified by:
    `getDynaClass` in interface `org.apache.commons.beanutils.DynaBean`

### getMap

    public java.util.Map getMap()

  Returns the `Map` containing the property values. This is done mostly to facilitate accessing the `DynaActionForm` through JavaBeans accessors, in order to use the JavaServer Pages Standard Tag Library.

  For instance, the normal JSTL EL syntax for accessing an `ActionForm` would be something like this:

        ${formbean.prop}

  The JSTL EL syntax for accessing a `DynaActionForm` looks something like this (because of the presence of this `getMap()` method):

        ${dynabean.map.prop}

### remove

    public void remove(java.lang.String name,
                       java.lang.String key)

  Remove any existing value for the specified key on the specified mapped property.

  Specified by:
    `remove` in interface `org.apache.commons.beanutils.DynaBean`
  Parameters:
    `name` - Name of the property for which a value is to be removed
    `key` - Key of the value to be removed
  Throws:
    `java.lang.IllegalArgumentException` - if there is no property of the specified name

### set

    public void set(java.lang.String name,
                    java.lang.Object value)

  Set the value of a simple property with the specified name.

  Specified by:
    `set` in interface `org.apache.commons.beanutils.DynaBean`
  Parameters:
    `name` - Name of the property whose value is to be set
    `value` - Value to which this property is to be set
  Throws:
    `org.apache.commons.beanutils.ConversionException` - if the specified value cannot be converted to the type required for this property
    `java.lang.IllegalArgumentException` - if there is no property of the specified name
    `java.lang.NullPointerException` - if the type specified for the property is invalid
    `java.lang.NullPointerException` - if an attempt is made to set a primitive property to null

### set

    public void set(java.lang.String name,
                    int index,
                    java.lang.Object value)

  Set the value of an indexed property with the specified name.

  Specified by:
    `set` in interface `org.apache.commons.beanutils.DynaBean`
  Parameters:
    `name` - Name of the property whose value is to be set
    `index` - Index of the property to be set
    `value` - Value to which this property is to be set
  Throws:
    `org.apache.commons.beanutils.ConversionException` - if the specified value cannot be converted to the type required for this property
    `java.lang.IllegalArgumentException` - if there is no property of the specified name
    `java.lang.IllegalArgumentException` - if the specified property exists, but is not indexed
    `java.lang.IndexOutOfBoundsException` - if the specified index is outside the range of the underlying property

### set

    public void set(java.lang.String name,
                    java.lang.String key,
                    java.lang.Object value)

  Set the value of a mapped property with the specified name.

  Specified by:
    `set` in interface `org.apache.commons.beanutils.DynaBean`
  Parameters:
    `name` - Name of the property whose value is to be set
    `key` - Key of the property to be set
    `value` - Value to which this property is to be set
  Throws:
    `org.apache.commons.beanutils.ConversionException` - if the specified value cannot be converted to the type required for this property
    `java.lang.IllegalArgumentException` - if there is no property of the specified name
    `java.lang.IllegalArgumentException` - if the specified property exists, but is not mapped

### toString

    public java.lang.String toString()

  Render a String representation of this object.

  Overrides:
    `toString` in class `java.lang.Object`

### setDynaActionFormClass

    void setDynaActionFormClass(DynaActionFormClass dynaClass)

  Set the DynaActionFormClass instance that we are associated with.

  Parameters:
    `dynaClass` - The DynaActionFormClass instance for this bean

### getDynaProperty

    protected org.apache.commons.beanutils.DynaProperty getDynaProperty(java.lang.String name)

  Return the property descriptor for the specified property name.

  Parameters:
    `name` - Name of the property for which to retrieve the descriptor
  Throws:
    `java.lang.IllegalArgumentException` - if this is not a valid property name for our DynaClass

### isDynaAssignable

    protected boolean isDynaAssignable(java.lang.Class dest,
                                       java.lang.Class source)

  Indicates if an object of the source class is assignable to the destination class.

  Parameters:
    `dest` - Destination class
    `source` - Source class

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2000-2003 - Apache Software Foundation